function [ outputSignal ] = distorSystem( inputSignal, params )
% ===   ,    
% ===  : ===
% inputSignal -    
% fs -  
% params.n -    (1 - ; 0 - )
% params.r -   - (1 - ; 0 - )
% params.snr0 -   - ( )
% params.rir -   ( )
% params.noise -  ( )

% ===  : ===
% outputSignal -    

% ===   ===
% 1)      (rever = 0  noise = 0);
% 2)    (rever = 0),   (noise = 1);
% 3)   (rever = 1),    (noise = 0);
% 4)     (rever = 1, noise = 1);
% 
%  1)     ;
%  2)       ;
%  3)        ;
%  4)        + 
%
%  2)  :
%    1)         
%    2) stdSpeech  stdNoise    
%    3)  snr:
%                snr = 20*log10(stdSpeech/stdNoise);
%    4)  snr   snr0  . - k0  :
%              k0 = 10^(0.05*(snr - snr0));
%    5)      :
%               sum = sig + k0*noise
%
%  4)  :
%    1)     :  (50 )  
%    2)       
%    3)  stdSpeech  ,   .2):
%         -         
%         - stdSpeech      
%    4)  . - k0    .2)-4)  2);
%    5) ,   .2),    ;
%    6)      
% =======================================================================
slength = length(inputSignal);

if (params.m == 1)
    m = 1;
elseif (params.m == 2)
    m = 2;
elseif (params.m == 3)
    m = 3;
else
    m = 4;
end

switch m
    case 1
        outputSignal = inputSignal;
    case 2
        fs = params.fs;
        detVoice = vad_LP(inputSignal,fs);  %  
        nullSilence = inputSignal.*detVoice;       %  
        sgnl = nonzeros(nullSilence);                % 
        varSpeech = var(sgnl);                     %  
        noise = params.noise(1:slength);             % 
        varNoise = var(noise);                       %  
        snr = 10*log10(varSpeech/varNoise);          %  snr
        k0 = 10^(0.05*(snr - params.snr0));          % .-
        outputSignal = inputSignal + k0*noise;%  
        outputSignal = outputSignal/max(abs(outputSignal))*0.99; % .
    case 3
        rir = params.rir;                           %  
        outputSignal = fftfilt(rir,inputSignal); %     ;
        outputSignal = outputSignal/max(abs(outputSignal))*0.99; % .
    case 4
        rir = params.rir;                 %  
        fs = params.fs;
        sample50ms = round(0.05*fs);    %   50 
        rir1 = rir(1:sample50ms);                  %   
        rir2 = [zeros(length(rir1),1); rir((sample50ms+1):end)];   %  
        outSig1 = fftfilt(rir1,inputSignal); %      ;
        
        detVoice = vad_LP(outSig1,fs);           %  
        nullSilence = outSig1.*detVoice;       %  
        sgnl = nonzeros(nullSilence);              %  
        varSpeech = var(sgnl);                     % std 
        noise = params.noise(1:slength);             % 
        varNoise = var(noise);                       %  
        snr = 10*log10(varSpeech/varNoise);                   %  snr
        k0 = 10^(0.05*(snr - params.snr0));          % .-
        
        outSig2 = fftfilt(rir2,inputSignal); %      ;
        outputSignal = outSig1 + outSig2 + k0*noise;  % .- + 
        outputSignal = outputSignal/max(abs(outputSignal))*0.99; % .
end

end
